#!/usr/bin/python
import sys
sys.path.append('lib/')
import os
import pickle

# ############### Input arguments #################
# 1) File containing original QV's
# 2) File to store the dictionary
# 3) File to store the p
# 4) File to store the distortion
###################################################

if (len(sys.argv) == 1):
  print >> sys.stderr, "Program use:"
  print >> sys.stderr, sys.argv[0] + " <file with original QV's> <outFile: dictionary> <outFile: p> <outFile: distortion>" 
  sys.exit()

# Get list of files
try:
  inFile = open(sys.argv[1])
except IOError:
  print >> sys.stderr, "Input file " + sys.argv[1] + " not found!"
  sys.exit()

# Create dictionaries. 
# tmp is only for the Yn sequence
tmp = {}
ctr = 0
numLines = 0
while 1:
  q_ori = inFile.readline()
  if not q_ori:
    break

  numLines += 1
  if (numLines%1000000 == 0):
    print numLines

  readlen = len(q_ori)-1

  for position in range(0,readlen):
    if position == 0:
      # First position
      tmpkey = (0, ord(q_ori[position]), ord(q_ori[position + 1]))
    elif position == readlen - 1:
      # Last position
      tmpkey = (ord(q_ori[position - 1]), ord(q_ori[position]), 0)
    else:
      # Other positions
      tmpkey = (ord(q_ori[position-1]), ord(q_ori[position]), ord(q_ori[position + 1]))

    if tmpkey not in tmp:
      tmp[tmpkey] = ctr
      ctr = ctr + 1

inFile.close()

numElements = len(tmp)
print "tmp dictionary len: %d" % numElements
rangeQV = 72	
# rangeQV = 200	

print "generating p"
p = [0]*numElements
distortion = [0]*rangeQV
for x in range(0,numElements):
  p[x] = [0]*rangeQV

print "generating distortion matrix"
for x in range(0, rangeQV):
  distortion[x] = [0]*rangeQV
  for xhat in range(0, rangeQV): 
    distortion[x][xhat] = (x - xhat)*(x - xhat)

# Store dictionary in file
print "storing dictionary"
pickle.dump( tmp, open(sys.argv[2], "wb") )

# Store p in file
print "storing p"
pickle.dump( p, open(sys.argv[3], "wb") )

# Store distortion matrix in file
print "storing distortion matrix"
pickle.dump( distortion, open(sys.argv[4], "wb") )


